//+------------------------------------------------------------------+
//|                                                 #JoGET_MA2b#.mq4 |
//|                                        Copyright  2009, masemus |
//|                                                masemus@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, masemus"
#property link      "masemus@yahoo.com"

#property indicator_chart_window
//--------------------------------------------------------------------
extern string  Indicator   = "JoGET_MA2b  2009, masemus";
//--------------------------------------------------------------------

#property indicator_buffers 8
#property indicator_color1 Gray
#property indicator_color2 C'255,206,215'
#property indicator_color3 C'180,245,180'
#property indicator_color4 Black
#property indicator_color5 C'255,255,255'
#property indicator_color6 LightGray
#property indicator_color7 Lime
#property indicator_color8 Red

#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 3
#property indicator_width5 1
#property indicator_width6 3
#property indicator_width7 3
#property indicator_width8 3

//---- input parameters
extern int MA_Period=8;
extern int MA_Method=0;
extern int MA_Price=0;
extern int MA_Array=14;
extern bool Show_BBands=true; 
extern int BBands=20;
extern int Dev=2;

//---- buffers
double buffer1[];
double buffer2[];
double upbuffer1[];
double dnbuffer1[];
double avg[];
double sDev[];
double upBB[];
double loBB[];
double buffer3[];

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int limit, counted_bars=IndicatorCounted();
   double cur1,cur2;
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   //---- macd counted in the 1-st additional buffer
   for(int i=0; i<limit; i++)
      buffer1[i]=iMA(NULL,0,MA_Period,0,MA_Method,MA_Price,i);
   //---- signal line counted in the 2-nd additional buffer
   for(i=0; i<limit; i++)
      buffer2[i]=iMAOnArray(buffer1,0,2,0,MA_Method,i);
   //
   bool up=true;
   for(i=limit; i>=0; i--)
   {
   buffer3[i]=iMAOnArray(buffer1,0,MA_Array,0,MA_Method,i);
   cur1=buffer1[i];
   cur2=buffer2[i];
      if(cur1>cur2) up=true;
      if(cur1<cur2) up=false;
      if(!up)
        {
         dnbuffer1[i]=cur1;
         upbuffer1[i]=EMPTY_VALUE;
        }
      else
        {
         upbuffer1[i]=cur1;
         dnbuffer1[i]=EMPTY_VALUE;
        }

      if(Show_BBands==true) {
        avg[i]=iMAOnArray(buffer1,0,BBands,0,MA_Method,i);
        sDev[i]=iStdDevOnArray(buffer1,0,BBands,0,MA_Method,i);
        upBB[i]=iMAOnArray(buffer1,0,BBands,0,MA_Method,i)+(Dev*(iStdDevOnArray(buffer1,0,BBands,0,MA_Method,i)));
        loBB[i]=iMAOnArray(buffer1,0,BBands,0,MA_Method,i)-(Dev*(iStdDevOnArray(buffer1,0,BBands,0,MA_Method,i)));
        }

   }

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   // IndicatorBuffers(8);
   SetIndexStyle(0,EMPTY_VALUE);
   SetIndexBuffer(0,avg);
   SetIndexStyle(1,EMPTY_VALUE);
   SetIndexBuffer(1,upBB);
   SetIndexStyle(2,EMPTY_VALUE);
   SetIndexBuffer(2,loBB);
   SetIndexStyle(3,EMPTY_VALUE);
   SetIndexBuffer(3,buffer3);
   SetIndexStyle(4,EMPTY_VALUE);
   SetIndexBuffer(4,buffer2);
   SetIndexStyle(5,EMPTY_VALUE);
   SetIndexBuffer(5,buffer1);
   SetIndexStyle(6,EMPTY_VALUE);
   SetIndexBuffer(6,upbuffer1);
   SetIndexStyle(7,EMPTY_VALUE);
   SetIndexBuffer(7,dnbuffer1);

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+



