//+------------------------------------------------------------------+
//|                                                     RXsar_1b.mq4 |
//|                                        Copyright  2009, masemus |
//|                                                masemus@yahoo.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, masemus"
#property link      "masemus@yahoo.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Aqua
#property indicator_color4 Gold
#property indicator_color5 Blue
#property indicator_color6 Red
#property indicator_color7 Aqua
#property indicator_color8 Gold
#property indicator_width1 3
#property indicator_width2 3
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 2
#property indicator_width6 2
#property indicator_width7 0
#property indicator_width8 0

//---- input parameters
extern int RX_period=14;
extern int RX_price=0;
extern int MA_period=14;
extern int MA_Method=0;
extern int MA_price=0;
extern double sar_Step=0.02;
extern double sar_Maximum=0.2;

//---- buffers
double UpBuffer1[];
double DnBuffer1[];
double UpBuffer2[];
double DnBuffer2[];
double UpBuffer3[];
double DnBuffer3[];
double UpBuffer4[];
double DnBuffer4[];

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) counted_bars=0;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
  
   for(int i = 0 ;i < limit ;i++)
   { 
      double c0adx=iADX(NULL,0,RX_period,RX_price,MODE_PLUSDI,i) - iADX(NULL,0,RX_period,RX_price,MODE_MINUSDI,i);
      double p1adx=iADX(NULL,0,RX_period,RX_price,MODE_PLUSDI,i+1) - iADX(NULL,0,RX_period,RX_price,MODE_MINUSDI,i+1);
      double p2adx=iADX(NULL,0,RX_period,RX_price,MODE_PLUSDI,i+2) - iADX(NULL,0,RX_period,RX_price,MODE_MINUSDI,i+2);
      double c0sig=iADX(NULL,0,RX_period,RX_price,MODE_MAIN,i) - 20;
      double p1sig=iADX(NULL,0,RX_period,RX_price,MODE_MAIN,i+1) - 20;
      double p2sig=iADX(NULL,0,RX_period,RX_price,MODE_MAIN,i+2) - 20;
      double c0rsi=iRSI(NULL,0,RX_period,RX_price,i) - 50;
      double p1rsi=iRSI(NULL,0,RX_period,RX_price,i+1) - 50;
      double p2rsi=iRSI(NULL,0,RX_period,RX_price,i+2) - 50;
      double upMA=iLow(NULL,0,i)-(1*Point);
      double dnMA=iHigh(NULL,0,i)+(1*Point);
      double cSAR=iSAR(NULL,0,sar_Step,sar_Maximum,i);
   // -----
        UpBuffer1[i] = EMPTY_VALUE;
        DnBuffer1[i] = EMPTY_VALUE;
        UpBuffer2[i] = EMPTY_VALUE;
        DnBuffer2[i] = EMPTY_VALUE;
        UpBuffer3[i] = EMPTY_VALUE;
        DnBuffer3[i] = EMPTY_VALUE;
        UpBuffer4[i] = EMPTY_VALUE;
        DnBuffer4[i] = EMPTY_VALUE;

   //:: formula signal_UP
      if(c0adx>p1adx&&c0sig>p1sig&&c0rsi>p1rsi)
      {  
        UpBuffer1[i] = upMA;
      }
      else
      {
        UpBuffer1[i] = EMPTY_VALUE;
      }

   //:: formula signal_DN
      if(c0adx<p1adx&&c0sig>p1sig&&c0rsi<p1rsi)
      {  
        DnBuffer1[i] = dnMA;
      }
      else
      {
        DnBuffer1[i] = EMPTY_VALUE;
      }

   //:: formula op_BUY
      if(p1adx<p2adx&&p1sig>p2sig&&p1rsi<p2rsi&&c0adx>p1adx&&c0sig>p1sig&&c0rsi>p1rsi)
      {  
        UpBuffer2[i] = upMA;
      }
      else
      {
        UpBuffer2[i] = EMPTY_VALUE;
      }

   //:: formula op_SELL
      if(p1adx>p2adx&&p1sig>p2sig&&p1rsi>p2rsi&&c0adx<p1adx&&c0sig>p1sig&&c0rsi<p1rsi)
      {  
        DnBuffer2[i] = dnMA;
      }
      else
      {
        DnBuffer2[i] = EMPTY_VALUE;
      }

   //:: formula signal_UP
      if(c0adx>p1adx&&c0sig>p1sig&&c0rsi>p1rsi)
      {  
        UpBuffer3[i] = cSAR;
      }
      else
      {
        UpBuffer3[i] = EMPTY_VALUE;
      }

   //:: formula signal_DN
      if(c0adx<p1adx&&c0sig>p1sig&&c0rsi<p1rsi)
      {  
        DnBuffer3[i] = cSAR;
      }
      else
      {
        DnBuffer3[i] = EMPTY_VALUE;
      }

   //:: formula op_BUY
      if(p1adx<p2adx&&p1sig>p2sig&&p1rsi<p2rsi&&c0adx>p1adx&&c0sig>p1sig&&c0rsi>p1rsi)
      {  
        UpBuffer4[i] = cSAR;
      }
      else
      {
        UpBuffer4[i] = EMPTY_VALUE;
      }

   //:: formula op_SELL
      if(p1adx>p2adx&&p1sig>p2sig&&p1rsi>p2rsi&&c0adx<p1adx&&c0sig>p1sig&&c0rsi<p1rsi)
      {  
        DnBuffer4[i] = cSAR;
      }
      else
      {
        DnBuffer4[i] = EMPTY_VALUE;
      }
      
   }

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   // IndicatorBuffers(8);
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexBuffer(0,UpBuffer2);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexBuffer(1,DnBuffer2);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexBuffer(2,UpBuffer1);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexBuffer(3,DnBuffer1);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexBuffer(4,UpBuffer4);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexBuffer(5,DnBuffer4);
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexBuffer(6,UpBuffer3);
   SetIndexStyle(7,DRAW_ARROW);
   SetIndexBuffer(7,DnBuffer3);

   SetIndexArrow(0,233);
   SetIndexArrow(1,234);
   SetIndexArrow(2,233);
   SetIndexArrow(3,234);
   SetIndexArrow(4,109);
   SetIndexArrow(5,109);
   SetIndexArrow(6,108);
   SetIndexArrow(7,108);
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);
  }
//+------------------------------------------------------------------+

